import Qt 4.7
import QtMobility.publishsubscribe 1.0
import Qt.labs.folderlistmodel 1.0

/* DOCME */
FocusScope {
    id: page

    signal exited

    Item {
        id: add_connection

        anchors.fill: parent

        TextCustom {
            id: title

            x: 70
            y: 65
            width: 200
            height: 20
            font.pointSize: 19
            text: qsTr("Add item")
        }

        TextCustom {
            id: subtitle

            anchors.top: title.bottom
            anchors.topMargin: 10
            anchors.left: title.left
            anchors.right: title.right

            width: title.width
            height: title.height
            font.pointSize: 10
            text: qsTr("Home Screen")
        }

        TextCustom {
            id: instructions

            anchors.top: subtitle.bottom
            anchors.topMargin: 45
            anchors.left: title.left

            width: title.width
            height: title.height
            text: qsTr("Select type of item to add:")
        }

        /*
        ValueSpaceSubscriber {
            id: gconf_connections_types
            path: "/apps/hedley_launcher/connection_types/list"
        }
        */

        QFileSystemModelQML {
            id: desktop_files

            rootPath: "/usr/share/applications/wyse_addons/"
            nameFilters: ["*.desktop"]
            nameFilterDisables: false
        }

        GridView {
            id: items

            anchors.left: instructions.left
            anchors.top: instructions.bottom
            anchors.topMargin: 20
            anchors.bottom: cancel.top
            anchors.bottomMargin: 40
            anchors.right: parent.right
            anchors.rightMargin: title.x

            flow: GridView.LeftToRight
            focus: true
            cellWidth: 130
            cellHeight: 120
            clip: true
            currentIndex: 0

            //model: gconf_connections_types.value
            model: desktop_files

            delegate: AddConnectionItem {
                id: application_delegate

                /*
                property string gconf_key
                property string gconf_desktop_file
                property ValueSpaceSubscriber gconf_desktop_file_subscriber:
                    ValueSpaceSubscriber {
                        path: "/apps/hedley_launcher/connection_types/"+model.modelData
                    }
                */
                property QLauncherApplication app

                //app: QLauncherApplication {desktop_file: gconf_desktop_file_subscriber.value}
                app: QLauncherApplication {desktop_file: filePath}

                width: items.cellWidth
                height: items.cellHeight
                icon: "image://icons/"+app.icon_name
                label: app.name
                onClicked: {
                    app.setFrameless()
                    app.launch()
                    connection_editor.application = app
                    connection_editor.focus = true
                    connection_editor.opacity = 1
                    add_connection.opacity = 0
                }
            }
        }

        ButtonText {
            id: cancel

            anchors.horizontalCenter: items.horizontalCenter
            anchors.bottom: parent.bottom
            anchors.bottomMargin: 80
            icon: "artwork/cancel.png"
            text: qsTr("Cancel")
            onClicked: page.exited()
        }
    }

    ConnectionEditor {
        id: connection_editor

        anchors.fill: parent
        opacity: 0

        onExited: {
            connection_editor.application = null
            connection_editor.focus = false
            connection_editor.opacity = 0
            add_connection.opacity = 1
            page.exited()
        }

        Behavior on opacity {NumberAnimation {duration: 200; easing.type: Easing.InOutQuad}}
    }
}
