import Qt 4.7

/* DOCME
*/
Item {
    property QLauncherApplication application

    signal cancelled

    /* FIXME: a bug somewhere in Qt makes it using childrenRect.width not work:
              it is correctly updated when title.width grows bigger but not when
              it grows smaller.
    */
    width: icon.width + labels.anchors.leftMargin + title.width
    height: childrenRect.height

    Image {
        id: icon

        source: application ? "image://icons/"+application.icon_name : source
        width: 64
        height: 64
        sourceSize.width: width
        sourceSize.height: height
    }

    Item {
        id: labels

        anchors.left: icon.right
        anchors.leftMargin: 20
        anchors.verticalCenter: icon.verticalCenter
        width: childrenRect.width
        height: childrenRect.height

        TextCustom {
            id: title

            text: application ? application.name : text
            width: paintedWidth
            height: paintedHeight
        }

        TextCustom {
            id: loading
            text: qsTr("Loading...")
            font.pointSize: 10

            anchors.top: title.bottom
            width: paintedWidth
            height: paintedHeight
        }
    }

    ButtonText {        
        text: qsTr("Home")
        anchors.top: labels.bottom
        anchors.topMargin: 40
        anchors.horizontalCenter: parent.horizontalCenter

        icon: "artwork/back.png"

        onClicked: {
            application.close()
            cancelled()
        }
    }
}
