import Qt 4.7

/* DOCME */
FocusScope {
    id: popup

    property QLauncherApplication connection
    property string connection_id
    property int padding: 35
    property int minimal_width: 280


    signal exited

    /* Make sure the title row never overflows outside the popup */
    width: Math.max(title.width, minimal_width) + 2*padding

    Rectangle {
        id: background
        opacity: 0.9

        color: "#181818"
        anchors.fill: parent
        anchors.margins: 7
    }

    BorderImage {
        id: border

        border.bottom: 9
        border.top: 9
        border.right: 9
        border.left: 9
        anchors.fill: parent
        source: "artwork/applications_border.png"
    }

    Row {
        id: title

        spacing: 22
        anchors.top: parent.top
        anchors.topMargin: parent.height*0.2
        anchors.horizontalCenter: parent.horizontalCenter

        Image {
            id: icon

            source: "artwork/delete.png"
            asynchronous: true
            smooth: false
            fillMode: Image.PreserveAspectFit
            sourceSize.width: width
            sourceSize.height: height
            width: 45
            height: 45
        }

        TextCustom {
            id: label

            anchors.verticalCenter: icon.verticalCenter

            width: paintedWidth
            height: paintedHeight
            clip: true
            text: connection ? "Delete " + connection.name + "?" : ""
        }
    }


    Item {
        id: buttons

        anchors.bottom: parent.bottom
        anchors.bottomMargin: padding-5
        anchors.left: parent.left
        anchors.right: parent.right

        ButtonFrameAndText {
            id: cancel

            anchors.left: parent.left
            anchors.leftMargin: padding
            anchors.bottom: parent.bottom

            text: "Cancel"
            onClicked: popup.exited()
        }

        ButtonFrameAndText {
            id: ok

            anchors.right: parent.right
            anchors.rightMargin: padding
            anchors.bottom: parent.bottom

            text: "OK"
            onClicked: {
                if(connection_id)
                    connection.removeFromConnectionsList(connection_id)
                else
                    connection.removeDesktopFile()

                popup.exited()
            }
        }
    }
}
