import Qt 4.7
import QtMobility.publishsubscribe 1.0
import Qt.labs.folderlistmodel 1.0

/* FIXME: unfinished */
Page {
    /*
    ValueSpaceSubscriber {
        id: gconf_connections
        path: "/apps/hedley_launcher/connections/list"
    }
    */

    QFileSystemModelQML {
        id: desktop_files
        /* Effectively calls QDesktopServices::storageLocation(QDesktopServices::HomeLocation) */
        rootPath: home_directory + "/Desktop"
        nameFilters: ["*.desktop"]
        nameFilterDisables: false
    }

    Applications {
        id: connections

        property bool contextual_actions_visible: false

        anchors.fill: parent
        focus: true

        onLaunching_applicationChanged: {
            if(launching_application == null)
                buttons_bar.opacity = 1
            else
                buttons_bar.opacity = 0
        }

        Image {
            id: stripes

            z: -1
            source: "artwork/stripes.png"
            opacity: connections.contextual_actions_visible ? 0.18 : 0.0

            anchors.fill: parent
            anchors.margins: 6
            fillMode: Image.Tile

            Behavior on opacity {NumberAnimation {duration: 200; easing.type: Easing.InOutQuad}}
        }


        //model: gconf_connections.value
        model: desktop_files

        delegate: Item {
            /* Trick to center Connections Item inside the grid cell */
            width: grid.cellWidth
            height: grid.cellHeight

            ConnectionsItem {
                id: application_delegate

                property QLauncherApplication app
                /*
                property ValueSpaceSubscriber gconf_desktop_file_subscriber:
                    ValueSpaceSubscriber {
                        path: "/apps/hedley_launcher/connections/"+model.modelData+"/desktop_file"
                    }
                */

                property QLauncherApplication editor_app:
                    QLauncherApplication {
                        desktop_file: {
                            if(application_delegate.app != null)
                                return "/usr/share/applications/wyse_addons/"+application_delegate.app.connection_type+".desktop"
                            else
                                return ""
                        }
                    }

                //app: QLauncherApplication {desktop_file: gconf_desktop_file_subscriber.value}
                app: QLauncherApplication {desktop_file: filePath}

                anchors.horizontalCenter: parent.horizontalCenter
                anchors.verticalCenter: parent.verticalCenter
                width: grid.delegate_width
                height: grid.delegate_height
                icon: "image://icons/"+app.icon_name
                label: app.name
                running: app.running
                contextual_actions_visible: connections.contextual_actions_visible
                onClicked: {
                    if(connections.contextual_actions_visible) {
                        /* edit mode */
                        /* execute the connection editor corresponding to the
                           type of the connection and passes as argument the
                           filename of the .desktop file of the connection
                           without its extension. */
                        var filename_index = app.desktop_file.lastIndexOf("/")+1
                        var basename = app.desktop_file.substring(filename_index).replace(".desktop", "")
                        editor_app.launch(basename)
                    }
                    else {
                        /* launching mode */
                        if(running) {
                            app.show()
                        }
                        else {
                            connections.launching_application = app
                            app.launch()
                        }
                    }
                }
                /* FIXME: liblauncher's Application object does not provide us with
                          a 'launching' property therefore we are using the
                          'running' property instead to hide the launching feedback.
                          That leads to a bug whereby failing to launch an
                          application will lead to an ever showing launching feedback.

                          A 'launching' property should use the startup notification
                          standard to be properly implemented:
                          http://standards.freedesktop.org/startup-notification-spec/startup-notification-0.1.txt
                */
                onRunningChanged: if(running) {
                    connections.launching_application = null
                }
                onRemoveClicked: {
                    //if(using_gconf) connection_removal.connection_id = model.modelData
                    connection_removal.connection = app
                    connection_removal.focus = true
                    connection_removal.opacity = 0.9
                }
            }
        }

        Behavior on opacity {NumberAnimation {duration: 200; easing.type: Easing.InOutQuad}}
    }


    ValueSpaceSubscriber {
        id: gconf_edit_mode_available
        path: "/apps/hedley_launcher/edit_mode_available"
    }

    Row {
        id: buttons_bar

        spacing: 15
        anchors.top: parent.bottom
        anchors.right: parent.right
        anchors.topMargin: 3
        anchors.rightMargin: 6

        Behavior on opacity {NumberAnimation {duration: 200; easing.type: Easing.InOutQuad}}

        ButtonText {
            id: add_item_button

            opacity: connections.contextual_actions_visible ? 1 : 0
            icon: "artwork/add.png"
            text: qsTr("Add item")

            onClicked: {
                add_connection.focus = true
                buttons_bar.opacity = 0
                connections.opacity = 0
                add_connection.opacity = 1
            }

        }

        ButtonText {
            id: edit_mode_button

            visible: gconf_edit_mode_available.value
            icon: connections.contextual_actions_visible ? "artwork/back.png" : "artwork/edit_mode.png"
            text: connections.contextual_actions_visible ? qsTr("Exit edit mode") : qsTr("Enter edit mode")

            onClicked: connections.contextual_actions_visible = !connections.contextual_actions_visible
        }
    }

    ConnectionRemovalPopup {
        id: connection_removal

        height: 180
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.verticalCenter: parent.verticalCenter
        opacity: 0

        onExited: {
            connections.focus = true
            connection_removal.opacity = 0
        }

        Behavior on opacity {NumberAnimation {duration: 200; easing.type: Easing.InOutQuad}}
    }

    AddConnection {
        id: add_connection

        anchors.fill: parent
        opacity: 0

        onExited: {
            connections.focus = true
            connections.opacity = 1
            buttons_bar.opacity = 1
            add_connection.opacity = 0
        }

        Behavior on opacity {NumberAnimation {duration: 200; easing.type: Easing.InOutQuad}}
    }
}
