#ifndef QFILESYSTEMMODELQML_H
#define QFILESYSTEMMODELQML_H

#include <QFileSystemModel>

class QFileSystemModelQML : public QFileSystemModel
{
    Q_OBJECT

    Q_PROPERTY(QString rootPath READ rootPath WRITE setRootPath NOTIFY rootPathChanged)
    Q_PROPERTY(QStringList nameFilters READ nameFilters WRITE setNameFilters)
    Q_PROPERTY(int count READ rowCount)

public:
    QFileSystemModelQML(QObject * parent = 0);

    /* Overriden methods from QAbstractItemModel */
    int rowCount(const QModelIndex & parent = QModelIndex()) const;
    QModelIndex	index(int row, int column, const QModelIndex & parent = QModelIndex()) const;
    bool hasChildren(const QModelIndex & parent = QModelIndex()) const;

    /* Overriden method from QFileSystemModel */
    QModelIndex setRootPath(const QString & newPath);

private slots:
    void reset();

private:
    /* Index of the rootPath. Cached for performance reasons. */
    QModelIndex rootIndex;
};

Q_DECLARE_METATYPE(QModelIndex)

#endif // QFILESYSTEMMODELQML_H
